;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega16L
;Program type        : Application
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 256 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "dcf.vec"
	.INCLUDE "dcf.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /***************************************************************************************
;       2 |---------------------------------------------------------------------------------------|
;       3 | Programmbeschreibung: | Mit diesem Programm kann das DCF-Signal mit einer             |
;       4 |                       | DCF-Antenne eingelesen werden.                                |
;       5 |---------------------------------------------------------------------------------------|
;       6 | Autor:                | Marcel Kaptein.                                               |
;       7 |                       | Wobei die Grundstruktur dieses Programmes auf einem Progamm   |
;       8 |                       | der Internetseite >> www.digital-hobby.de << basiert.         |
;       9 |                       | Das Programm auf der Internetseite funktionierte aber leider  |
;      10 |                       | nicht.                                                        |
;      11 |-----------------------|---------------------------------------------------------------|
;      12 | Besonderheiten:       | In diesem Programm gibt es, im vergleich zu dem im Internet,  |
;      13 |                       | noch einige ander, zustzliche Funktionen.                    |
;      14 |                       | Es wird z.B. auch der Tag, Monat und das Jahr eingelesen.     |
;      15 |                       | Ebenfalls gibt es eine Korrektur fr die Uhr, falls sie ohne  |
;      16 |                       | dem DCF-Signal luft. ( kein Empfang! )                       |
;      17 |                       | Fr den Uhr-Status werden auf dem Display drei verschiedene   |
;      18 |                       | Symbole angezeigt. Fr: Uhr luft mit oder ohne               |
;      19 |                       | Synkronisation, oder das einlesen des Signales ist gerade     |
;      20 |                       | in arbeit.                                                    |
;      21 |---------------------------------------------------------------------------------------|
;      22 | Anschluss:            | Die DCF-Antenne wird am Port D, Pin 2 (INTO) angeschlossen.   |
;      23 |                       | Zustzlich wird auch der Interrupt 0 bentigt.                |
;      24 |                       | Von der Antenne ist der >NICHT-invertierender AUSGANG<        |
;      25 |                       | zu benutzen!!                                                 |
;      26 |-----------------------|---------------------------------------------------------------|
;      27 | Peripherie:           |                                                               |
;      28 | Timer 0               | Der Timer muss mit einer Taktung von 4MHz laufen. Auch der    |
;      29 |                       | "overflow- Interrupt" wird bentigt.                          |
;      30 |,,,,,,,,,,,,,,,,,,,,,,,|,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,|
;      31 | Interrupt 0           | Die DCF-Antenne wird direkt an dem Interrupt angeschlossen.   |
;      32 |                       | Dabei ist darauf zu achten das der Interrupt auf steigende    |
;      33 |                       | Flanke reagiert.                                              |
;      34 |-----------------------|---------------------------------------------------------------|
;      35 ****************************************************************************************/
;      36 
;      37 
;      38 #include <dcf.h>
_vergangenes_dcf:
	.BYTE 0x6
_zaehler_letztes_dcf:
	.BYTE 0x1
_faktor:
	.BYTE 0x2
_dcf:
	.BYTE 0xA

	.CSEG
_sonderzeichen_laden:
	SBIW R28,24
	LDI  R24,24
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x19*2)
	LDI  R31,HIGH(_0x19*2)
	CALL __INITLOCB
	ST   -Y,R16
;	i -> R16
;	antenne_0 -> Y+17
;	antenne_1 -> Y+9
;	antenne_2 -> Y+1
	LDI  R16,LOW(0)
_0x1B:
	LDI  R30,LOW(8)
	CP   R30,R16
	BRLO _0x1C
	MOV  R30,R16
	SUBI R30,-LOW(64)
	CALL SUBOPT_0x0
	MOVW R26,R28
	ADIW R26,18
	CALL SUBOPT_0x1
	SUBI R16,-1
	RJMP _0x1B
_0x1C:
	LDI  R16,LOW(0)
_0x1E:
	LDI  R30,LOW(8)
	CP   R30,R16
	BRLO _0x1F
	MOV  R30,R16
	SUBI R30,-LOW(72)
	CALL SUBOPT_0x0
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x1
	SUBI R16,-1
	RJMP _0x1E
_0x1F:
	LDI  R16,LOW(0)
_0x21:
	LDI  R30,LOW(8)
	CP   R30,R16
	BRLO _0x22
	MOV  R30,R16
	SUBI R30,-LOW(80)
	CALL SUBOPT_0x0
	MOVW R26,R28
	ADIW R26,2
	CALL SUBOPT_0x1
	SUBI R16,-1
	RJMP _0x21
_0x22:
	LDD  R16,Y+0
	ADIW R28,25
	RET
_checkPBit:
	CALL __SAVELOCR3
;	data -> Y+4
;	pb -> Y+3
;	t -> R16
;	i -> R17
;	p -> R18
	LDI  R16,1
	LDI  R17,0
	LDI  R18,0
	LDI  R17,LOW(0)
_0x25:
	CPI  R17,8
	BRSH _0x26
	MOV  R30,R16
	LDD  R26,Y+4
	AND  R30,R26
	CP   R16,R30
	BRNE _0x27
	CPI  R18,0
	BRNE _0x28
	LDI  R18,LOW(1)
	RJMP _0x29
_0x28:
	LDI  R18,LOW(0)
_0x29:
_0x27:
	LSL  R16
	SUBI R17,-1
	RJMP _0x25
_0x26:
	LDD  R26,Y+3
	CP   R18,R26
	BRNE _0x2A
	CLR  R30
	RJMP _0x132
_0x2A:
	LDI  R30,LOW(1)
_0x132:
	CALL __LOADLOCR3
	ADIW R28,5
	RET
_dcf_uhr_einlesen:

	.DSEG
_impuls_S2:
	.BYTE 0x1

	.CSEG
	__GETW1R 4,5
	ADIW R30,1
	__PUTW1R 4,5
	__GETW1R 6,7
	ADIW R30,1
	__PUTW1R 6,7
	LDI  R30,LOW(15620)
	LDI  R31,HIGH(15620)
	CP   R4,R30
	CPC  R5,R31
	BRLO _0x2D
	INC  R8
	CLR  R4
	CLR  R5
_0x2D:
	LDI  R30,LOW(60)
	CP   R30,R8
	BRNE _0x2E
	CLR  R8
	INC  R9
	__POINTW2MN _dcf,8
	CALL SUBOPT_0x2
	__GETW2MN _dcf,8
	CPI  R26,LOW(0x2)
	LDI  R30,HIGH(0x2)
	CPC  R27,R30
	BRLO _0x2F
	CLR  R30
	__PUTB1MN _dcf,7
_0x2F:
_0x2E:
	LDI  R30,LOW(60)
	CP   R30,R9
	BRNE _0x30
	CLR  R9
	INC  R10
_0x30:
	LDI  R30,LOW(24)
	CP   R30,R10
	BRNE _0x31
	CLR  R10
	INC  R11
	INC  R12
_0x31:
	LDI  R30,LOW(7)
	CP   R30,R12
	BRNE _0x32
	CLR  R12
_0x32:
	LDI  R30,LOW(2)
	CP   R30,R8
	BRNE _0x34
	__GETW1MN _dcf,8
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x35
_0x34:
	RJMP _0x33
_0x35:
	CLT
	BLD  R2,0
_0x33:
	LDI  R30,LOW(3)
	CP   R30,R8
	BRNE _0x37
	SBRC R2,0
	RJMP _0x37
	__GETW1MN _dcf,8
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x38
_0x37:
	RJMP _0x36
_0x38:
	DEC  R8
	SET
	BLD  R2,0
	LDS  R30,_faktor
	LDS  R31,_faktor+1
	ADIW R30,1
	STS  _faktor,R30
	STS  _faktor+1,R31
_0x36:
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BREQ _0x39
	LDI  R30,LOW(2500)
	LDI  R31,HIGH(2500)
	CP   R6,R30
	CPC  R7,R31
	BRSH _0x3A
	CLR  R30
	STS  _impuls_S2,R30
_0x3A:
	LDI  R30,LOW(2500)
	LDI  R31,HIGH(2500)
	CP   R30,R6
	CPC  R31,R7
	BRSH _0x3B
	LDI  R30,LOW(1)
	STS  _impuls_S2,R30
_0x3B:
	RJMP _0x3C
_0x39:
	LDS  R26,_impuls_S2
	CPI  R26,LOW(0x3)
	BREQ _0x3E
	__GETB2MN _dcf,7
	CPI  R26,LOW(0x0)
	BREQ _0x3E
	LDI  R30,LOW(1200)
	LDI  R31,HIGH(1200)
	CP   R30,R6
	CPC  R31,R7
	BRLO _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
	LDS  R26,_dcf
	CPI  R26,LOW(0x5)
	BRNE _0x40
	CLR  R30
	__PUTB1MN _dcf,1
	__PUTB1MN _dcf,2
	__PUTB1MN _dcf,3
	__PUTB1MN _dcf,4
	__PUTB1MN _dcf,5
	__PUTB1MN _dcf,6
_0x40:
	LDS  R26,_dcf
	CPI  R26,LOW(0x16)
	BRLO _0x42
	LDI  R30,LOW(28)
	CP   R30,R26
	BRSH _0x43
_0x42:
	RJMP _0x41
_0x43:
	__POINTW2MN _dcf,1
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__POINTW2MN _dcf,1
	PUSH R27
	PUSH R26
	LD   R30,X
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	POP  R26
	POP  R27
	ST   X,R30
_0x41:
	LDS  R26,_dcf
	CPI  R26,LOW(0x1D)
	BRNE _0x44
	__GETB1MN _dcf,1
	CALL SUBOPT_0x5
	BRNE _0x45
	__GETB1MN _dcf,1
	ST   -Y,R30
	CALL _bcd2bin
	__PUTB1MN _dcf,1
	RJMP _0x46
_0x45:
	CLR  R30
	__PUTB1MN _dcf,7
_0x46:
_0x44:
	LDS  R26,_dcf
	CPI  R26,LOW(0x1E)
	BRLO _0x48
	LDI  R30,LOW(35)
	CP   R30,R26
	BRSH _0x49
_0x48:
	RJMP _0x47
_0x49:
	__POINTW2MN _dcf,2
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__POINTW2MN _dcf,2
	PUSH R27
	PUSH R26
	LD   R30,X
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	POP  R26
	POP  R27
	ST   X,R30
_0x47:
	LDS  R26,_dcf
	CPI  R26,LOW(0x24)
	BRNE _0x4A
	__POINTW2MN _dcf,2
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__GETB1MN _dcf,2
	CALL SUBOPT_0x5
	BRNE _0x4B
	__GETB1MN _dcf,2
	ST   -Y,R30
	CALL _bcd2bin
	__PUTB1MN _dcf,2
	RJMP _0x4C
_0x4B:
	CLR  R30
	__PUTB1MN _dcf,7
_0x4C:
_0x4A:
	LDS  R26,_dcf
	CPI  R26,LOW(0x25)
	BRLO _0x4E
	LDI  R30,LOW(42)
	CP   R30,R26
	BRSH _0x4F
_0x4E:
	RJMP _0x4D
_0x4F:
	__POINTW2MN _dcf,3
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__POINTW2MN _dcf,3
	PUSH R27
	PUSH R26
	LD   R30,X
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	POP  R26
	POP  R27
	ST   X,R30
_0x4D:
	LDS  R26,_dcf
	CPI  R26,LOW(0x2A)
	BRNE _0x50
	__POINTW2MN _dcf,3
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__GETB1MN _dcf,3
	ST   -Y,R30
	CALL _bcd2bin
	__PUTB1MN _dcf,3
_0x50:
	LDS  R26,_dcf
	CPI  R26,LOW(0x2B)
	BRLO _0x52
	LDI  R30,LOW(45)
	CP   R30,R26
	BRSH _0x53
_0x52:
	RJMP _0x51
_0x53:
	__POINTW2MN _dcf,4
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__POINTW2MN _dcf,4
	PUSH R27
	PUSH R26
	LD   R30,X
	PUSH R30
	LDS  R30,_impuls_S2
	LSL  R30
	LSL  R30
	POP  R26
	OR   R30,R26
	POP  R26
	POP  R27
	ST   X,R30
_0x51:
	LDS  R26,_dcf
	CPI  R26,LOW(0x2D)
	BRNE _0x54
	__GETB1MN _dcf,4
	ST   -Y,R30
	CALL _bcd2bin
	__PUTB1MN _dcf,4
_0x54:
	LDS  R26,_dcf
	CPI  R26,LOW(0x2E)
	BRLO _0x56
	LDI  R30,LOW(49)
	CP   R30,R26
	BRSH _0x57
_0x56:
	RJMP _0x55
_0x57:
	__POINTW2MN _dcf,5
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__POINTW2MN _dcf,5
	PUSH R27
	PUSH R26
	LD   R30,X
	PUSH R30
	LDS  R30,_impuls_S2
	CALL __LSLB3
	POP  R26
	OR   R30,R26
	POP  R26
	POP  R27
	ST   X,R30
_0x55:
	LDS  R26,_dcf
	CPI  R26,LOW(0x32)
	BRNE _0x58
	__GETB1MN _dcf,5
	ST   -Y,R30
	CALL _bcd2bin
	__PUTB1MN _dcf,5
_0x58:
	LDS  R26,_dcf
	CPI  R26,LOW(0x33)
	BRLO _0x5A
	LDI  R30,LOW(57)
	CP   R30,R26
	BRSH _0x5B
_0x5A:
	RJMP _0x59
_0x5B:
	__POINTW2MN _dcf,6
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__POINTW2MN _dcf,6
	PUSH R27
	PUSH R26
	LD   R30,X
	PUSH R30
	LDS  R30,_impuls_S2
	CALL __LSLB3
	SWAP R30
	ANDI R30,0xF0
	POP  R26
	OR   R30,R26
	POP  R26
	POP  R27
	ST   X,R30
_0x59:
	LDS  R26,_dcf
	CPI  R26,LOW(0x3A)
	BRNE _0x5C
	__POINTW2MN _dcf,6
	PUSH R27
	PUSH R26
	LD   R30,X
	LSR  R30
	POP  R26
	POP  R27
	ST   X,R30
	__GETB1MN _dcf,6
	ST   -Y,R30
	CALL _bcd2bin
	__PUTB1MN _dcf,6
_0x5C:
	LDI  R30,LOW(3)
	STS  _impuls_S2,R30
_0x3D:
_0x3C:
	MOV  R30,R8
	ADIW R28,2
	RET
_dcf_interrupt_aufruf:
	LDI  R30,LOW(28000)
	LDI  R31,HIGH(28000)
	CP   R30,R6
	CPC  R31,R7
	BRLO PC+3
	JMP _0x5E
	CLR  R30
	CLR  R31
	__PUTW1MN _dcf,8
	STS  _dcf,R30
	__GETB2MN _dcf,7
	CPI  R26,LOW(0x1)
	BRSH _0x5F
	LDI  R30,LOW(1)
	__PUTB1MN _dcf,7
	LDI  R30,LOW(3)
	STS  _zaehler_letztes_dcf,R30
	RJMP _0x60
_0x5F:
	__GETB2MN _dcf,1
	LDI  R30,LOW(60)
	CP   R30,R26
	BRLO _0x62
	__GETB2MN _dcf,2
	LDI  R30,LOW(24)
	CP   R30,R26
	BRSH _0x61
_0x62:
	CLR  R30
	__PUTB1MN _dcf,7
	__PUTB1MN _dcf,2
	__PUTB1MN _dcf,1
	RJMP _0x64
_0x61:
	CLR  R8
	LDS  R30,_zaehler_letztes_dcf
	SUBI R30,LOW(1)
	STS  _zaehler_letztes_dcf,R30
	LDI  R26,LOW(_vergangenes_dcf)
	LDI  R27,HIGH(_vergangenes_dcf)
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	__GETB1MN _dcf,2
	CLR  R31
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	CALL __MULW12
	PUSH R31
	PUSH R30
	__GETB1MN _dcf,1
	POP  R26
	POP  R27
	CLR  R31
	ADD  R30,R26
	ADC  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
_0x64:
	__GETB2MN _dcf,7
	CPI  R26,LOW(0x2)
	BRNE _0x65
	__GETBRMN _dcf,2,10
	__GETBRMN _dcf,1,9
	LDS  R8,_dcf
	__GETBRMN _dcf,3,11
	__GETBRMN _dcf,4,12
	__GETBRMN _dcf,5,13
	__GETBRMN _dcf,6,14
_0x65:
	LDS  R30,_zaehler_letztes_dcf
	CPI  R30,0
	BRNE _0x66
	LDS  R30,_vergangenes_dcf
	LDS  R31,_vergangenes_dcf+1
	SBIW R30,1
	PUSH R31
	PUSH R30
	__GETW1MN _vergangenes_dcf,2
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x68
	__POINTW2MN _vergangenes_dcf,2
	CALL __GETW1P
	SBIW R30,1
	PUSH R31
	PUSH R30
	__GETW1MN _vergangenes_dcf,4
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x69
_0x68:
	RJMP _0x67
_0x69:
	__GETBRMN _dcf,2,10
	__GETBRMN _dcf,1,9
	LDS  R8,_dcf
	__GETBRMN _dcf,3,11
	__GETBRMN _dcf,4,12
	__GETBRMN _dcf,5,13
	__GETBRMN _dcf,6,14
_0x67:
	LDI  R30,LOW(2)
	__PUTB1MN _dcf,7
	LDI  R30,LOW(3)
	STS  _zaehler_letztes_dcf,R30
_0x66:
	CLR  R4
	CLR  R5
_0x60:
_0x5E:
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	CP   R30,R6
	CPC  R31,R7
	BRSH _0x6A
	CLR  R6
	CLR  R7
	LDI  R26,LOW(_dcf)
	LDI  R27,HIGH(_dcf)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
_0x6A:
	RET
_dcf_uhrzeit_anzeigen:
	SBIW R28,19
;	zeit -> Y+10
;	datum -> Y+0
	SBRS R8,0
	RJMP _0x6C
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,0
	CALL SUBOPT_0x6
	LDI  R24,12
	RJMP _0x133
_0x6C:
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,15
	CALL SUBOPT_0x6
	LDI  R24,12
_0x133:
	CALL _sprintf
	ADIW R28,16
	TST  R12
	BRNE _0x6E
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x6E:
	LDI  R30,LOW(1)
	CP   R30,R12
	BRNE _0x6F
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x6F:
	LDI  R30,LOW(2)
	CP   R30,R12
	BRNE _0x70
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,38
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x70:
	LDI  R30,LOW(3)
	CP   R30,R12
	BRNE _0x71
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,42
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x71:
	LDI  R30,LOW(4)
	CP   R30,R12
	BRNE _0x72
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,46
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x72:
	LDI  R30,LOW(5)
	CP   R30,R12
	BRNE _0x73
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,50
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x73:
	LDI  R30,LOW(6)
	CP   R30,R12
	BRNE _0x74
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,54
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x74:
	LDI  R30,LOW(10)
	CP   R11,R30
	BRSH _0x75
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,58
	CALL SUBOPT_0x7
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
_0x75:
	LDI  R30,LOW(10)
	CP   R11,R30
	BRLO _0x76
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,65
	CALL SUBOPT_0x7
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
_0x76:
	LDI  R30,LOW(1)
	CP   R30,R13
	BRNE _0x77
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x77:
	LDI  R30,LOW(2)
	CP   R30,R13
	BRNE _0x78
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,75
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x78:
	LDI  R30,LOW(3)
	CP   R30,R13
	BRNE _0x79
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,79
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,81
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0xE1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,85
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x79:
	LDI  R30,LOW(4)
	CP   R30,R13
	BRNE _0x7A
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,87
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x7A:
	LDI  R30,LOW(5)
	CP   R30,R13
	BRNE _0x7B
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,91
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x7B:
	LDI  R30,LOW(6)
	CP   R30,R13
	BRNE _0x7C
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,95
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x7C:
	LDI  R30,LOW(7)
	CP   R30,R13
	BRNE _0x7D
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,99
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x7D:
	LDI  R30,LOW(8)
	CP   R30,R13
	BRNE _0x7E
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,103
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x7E:
	LDI  R30,LOW(9)
	CP   R30,R13
	BRNE _0x7F
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,107
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x7F:
	LDI  R30,LOW(10)
	CP   R30,R13
	BRNE _0x80
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,111
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x80:
	LDI  R30,LOW(11)
	CP   R30,R13
	BRNE _0x81
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,115
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x81:
	LDI  R30,LOW(12)
	CP   R30,R13
	BRNE _0x82
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _107,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
_0x82:
	__POINTW2MN _dcf,7
	LD   R30,X
	CPI  R30,LOW(0x2)
	BRNE _0x86
	CALL SUBOPT_0x8
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _faktor,R30
	STS  _faktor+1,R31
	RJMP _0x85
_0x86:
	CPI  R30,LOW(0x1)
	BRNE _0x87
	CALL SUBOPT_0x8
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_putchar
	RJMP _0x85
_0x87:
	CPI  R30,0
	BRNE _0x85
	CALL SUBOPT_0x8
	CLR  R30
	ST   -Y,R30
	CALL _lcd_putchar
_0x85:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x9
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	LDI  R30,LOW(11)
	CALL SUBOPT_0x9
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	ADIW R28,19
	RET
;      39 #include <mega16.h>
;      40 
;      41 
;      42 unsigned char neusekunde; // |-- Diese Variablen werden bentigt, damit die Uhr auch wirlich

	.DSEG
_neusekunde:
	.BYTE 0x1
;      43 unsigned char altsekunde; // |   nur bei jeder neuen Sekunde nur ein mal auf dem Display
_altsekunde:
	.BYTE 0x1
;      44                           //     geschrieben wird.
;      45 
;      46 
;      47 #asm                      // LDC-Display am PORT C
;      48    .equ __lcd_port=0x15   
   .equ __lcd_port=0x15   
;      49 #endasm

;      50 #include <lcd.h>
;      51 
;      52 
;      53 /*********************************************************************/
;      54 /* Timer_0 Interrupt-Service Routine                                 */
;      55 /*                                                                   */
;      56 /* Der Timer_0 luft mit einem Takt von 4MHz. Der Timer_0 hat 8 bit, */
;      57 /* also 256 Schritte. Somit dauert einen Takt des Timers 64s.       */
;      58 /* [ (4MHz/256) = 15625 -> *-1 = 64s]                               */
;      59 
;      60 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      61 {

	.CSEG
_timer0_ovf_isr:
	CALL __SAVEISR
;      62  unsigned char *antenne;	// diese Variable bentigt man um den Wert am
;      63 			        // PORT D,Pin 2 an eine Funktion
;      64 			        // in dcf.h zu bergeben
;      65 			
;      66  antenne = PIND.2;              // bekommt den Wert der am Port D Pin 2
	SBIW R28,2
;	*antenne -> Y+0
	CLR  R30
	SBIC 0x10,2
	LDI  R30,1
	CLR  R31
	ST   Y,R30
	STD  Y+1,R31
;      67  				// anliegt. (DCF_Antenne)
;      68 
;      69 //  |-- diese Variable bekommt den >momentanen< Wert von
;      70 //  |   "uhrwerk_sekunde" aus dcf.h! Die Variable wird
;      71 //  |   im Hauptprogramm verwendet.
;      72 //  |
;      73 //  |                            |-- bergabe des Wertes von Port D, Pin 2
;      74 //  |                            | 
;      75 neusekunde = dcf_uhr_einlesen(antenne);	// Aufruf der Funktion in dcf.h
	ST   -Y,R31
	ST   -Y,R30
	CALL _dcf_uhr_einlesen
	STS  _neusekunde,R30
;      76 }
	ADIW R28,2
	CALL __LOADISR
	RETI
;      77 /*********************************************************************/
;      78 
;      79 
;      80 
;      81 
;      82 /*********************************************************************/
;      83 /* Interrupt-Service Routine                                         */
;      84 /*                                                                   */
;      85 /* Dieser Interrupt wird durch die DCF-Antenne ausgelst             */
;      86 
;      87 
;      88 interrupt [EXT_INT0] void ext_int0_isr(void)
;      89 {
_ext_int0_isr:
	CALL __SAVEISR
;      90  dcf_interrupt_aufruf();	// Aufruf der Funktion in dcf.h
	CALL _dcf_interrupt_aufruf
;      91 }
	CALL __LOADISR
	RETI
;      92 /*********************************************************************/
;      93 
;      94 
;      95 
;      96 
;      97 void main(void)
;      98 {
_main:
;      99 
;     100 // Port D Initialisierung
;     101 PORTD=0xff;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     102 DDRD=0x00;
	CLR  R30
	OUT  0x11,R30
;     103 
;     104 // Timer_0 Initialisierung
;     105 TCCR0=0x01;     // 4MHz
	LDI  R30,LOW(1)
	OUT  0x33,R30
;     106 TCNT0=0x00;
	CLR  R30
	OUT  0x32,R30
;     107 OCR0=0x00;
	OUT  0x3C,R30
;     108 
;     109 // Externer Interrupt INT0
;     110 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     111 MCUCR=0x03;	// Steigende Flanke
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     112 MCUCSR=0x00;
	CLR  R30
	OUT  0x34,R30
;     113 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     114 
;     115 // Timer & Interrupt Initialisierung
;     116 TIMSK=0x05;
	LDI  R30,LOW(5)
	OUT  0x39,R30
;     117 
;     118 // LCD Module Initialisieren
;     119 lcd_init(20);      // LCD mit 20 Zeilen            
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_init
;     120 
;     121 
;     122 /* WICHTIG FR DIE SYMBOLE AUF DEM DISPLAY */
;     123 // Laden der Sonderzeichen in das LCD
;     124 sonderzeichen_laden();	
	CALL _sonderzeichen_laden
;     125 
;     126 // Global enable interrupts
;     127 #asm("sei")
	sei
;     128 
;     129 
;     130 while (1)
_0x8C:
;     131  {
;     132    if(altsekunde!=neusekunde)     // ist der Wert ungleich, dann war
	LDS  R30,_neusekunde
	LDS  R26,_altsekunde
	CP   R30,R26
	BREQ _0x8F
;     133     { 				  // ein Sekundenwechsel.
;     134      dcf_uhrzeit_anzeigen();	  // Aufruf der Funktion in dcf.h.
	CALL _dcf_uhrzeit_anzeigen
;     135      altsekunde = neusekunde;     // die altsekunde neu berschreiben.
	LDS  R30,_neusekunde
	STS  _altsekunde,R30
;     136     }                              
;     137 
;     138  
;     139  }; // Ende while
_0x8F:
	RJMP _0x8C
;     140 }   // Ende main
_0x90:
	RJMP _0x90
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G2:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	CALL __lcd_ready
	LDD  R30,Y+1
	CALL SUBOPT_0xA
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	ST   -Y,R30
	CALL __lcd_write_data
	ADIW R28,2
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G2:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G2)
	SBCI R31,HIGH(-__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	CALL SUBOPT_0xA
	LDI  R30,LOW(12)
	CALL SUBOPT_0xA
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	CLR  R30
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x98
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	CLR  R30
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x98:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G2:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	CALL SUBOPT_0xB
	CALL SUBOPT_0xB
	CALL SUBOPT_0xB
	CALL __long_delay_G2
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G2
	CALL __long_delay_G2
	LDI  R30,LOW(40)
	CALL SUBOPT_0xC
	LDI  R30,LOW(4)
	CALL SUBOPT_0xC
	LDI  R30,LOW(133)
	CALL SUBOPT_0xC
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0x9D
	CLR  R30
	RJMP _0x131
_0x9D:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x131:
	ADIW R28,1
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0xD4
	CALL SUBOPT_0x2
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xD5
_0xD4:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0xD5:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0xD7:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0xD9
	MOV  R30,R16
	CPI  R30,0
	BRNE _0xDD
	CPI  R19,37
	BRNE _0xDE
	LDI  R16,LOW(1)
	RJMP _0xDF
_0xDE:
	CALL SUBOPT_0xD
_0xDF:
	RJMP _0xDC
_0xDD:
	CPI  R30,LOW(0x1)
	BRNE _0xE0
	CPI  R19,37
	BRNE _0xE1
	CALL SUBOPT_0xD
	LDI  R16,LOW(0)
	RJMP _0xDC
_0xE1:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xE2
	LDI  R17,LOW(1)
	RJMP _0xDC
_0xE2:
	CPI  R19,43
	BRNE _0xE3
	LDI  R21,LOW(43)
	RJMP _0xDC
_0xE3:
	CPI  R19,32
	BRNE _0xE4
	LDI  R21,LOW(32)
	RJMP _0xDC
_0xE4:
	RJMP _0xE5
_0xE0:
	CPI  R30,LOW(0x2)
	BRNE _0xE6
_0xE5:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xE7
	ORI  R17,LOW(128)
	RJMP _0xDC
_0xE7:
	RJMP _0xE8
_0xE6:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0xDC
_0xE8:
	CPI  R19,48
	BRLO _0xEB
	CPI  R19,58
	BRLO _0xEC
_0xEB:
	RJMP _0xEA
_0xEC:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xDC
_0xEA:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xF0
	CALL SUBOPT_0xE
	LD   R30,X
	CALL SUBOPT_0xF
	RJMP _0xF1
_0xF0:
	CPI  R30,LOW(0x73)
	BRNE _0xF3
	CALL SUBOPT_0xE
	CALL SUBOPT_0x10
	CALL _strlen
	MOV  R16,R30
	RJMP _0xF4
_0xF3:
	CPI  R30,LOW(0x70)
	BRNE _0xF6
	CALL SUBOPT_0xE
	CALL SUBOPT_0x10
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xF4:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xF7
_0xF6:
	CPI  R30,LOW(0x64)
	BREQ _0xFA
	CPI  R30,LOW(0x69)
	BRNE _0xFB
_0xFA:
	ORI  R17,LOW(4)
	RJMP _0xFC
_0xFB:
	CPI  R30,LOW(0x75)
	BRNE _0xFD
_0xFC:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xFE
_0xFD:
	CPI  R30,LOW(0x58)
	BRNE _0x100
	ORI  R17,LOW(8)
	RJMP _0x101
_0x100:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x12F
_0x101:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xFE:
	SBRS R17,2
	RJMP _0x103
	CALL SUBOPT_0xE
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x104
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x104:
	CPI  R21,0
	BREQ _0x105
	SUBI R16,-LOW(1)
	RJMP _0x106
_0x105:
	ANDI R17,LOW(251)
_0x106:
	RJMP _0x107
_0x103:
	CALL SUBOPT_0xE
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x107:
_0xF7:
	SBRC R17,0
	RJMP _0x108
_0x109:
	CP   R16,R20
	BRSH _0x10B
	SBRS R17,7
	RJMP _0x10C
	SBRS R17,2
	RJMP _0x10D
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x10E
_0x10D:
	LDI  R19,LOW(48)
_0x10E:
	RJMP _0x10F
_0x10C:
	LDI  R19,LOW(32)
_0x10F:
	CALL SUBOPT_0xD
	SUBI R20,LOW(1)
	RJMP _0x109
_0x10B:
_0x108:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x110
_0x111:
	CPI  R18,0
	BREQ _0x113
	SBRS R17,3
	RJMP _0x114
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x134
_0x114:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x134:
	ST   -Y,R30
	CALL SUBOPT_0x11
	CPI  R20,0
	BREQ _0x116
	SUBI R20,LOW(1)
_0x116:
	SUBI R18,LOW(1)
	RJMP _0x111
_0x113:
	RJMP _0x117
_0x110:
_0x119:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x11B
	SBRS R17,3
	RJMP _0x11C
	SUBI R19,-LOW(7)
	RJMP _0x11D
_0x11C:
	SUBI R19,-LOW(39)
_0x11D:
_0x11B:
	SBRC R17,4
	RJMP _0x11F
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x121
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x120
_0x121:
	ORI  R17,LOW(16)
	RJMP _0x123
_0x120:
	CP   R20,R18
	BRLO _0x125
	SBRS R17,0
	RJMP _0x126
_0x125:
	RJMP _0x124
_0x126:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x127
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x123:
	SBRS R17,2
	RJMP _0x128
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x11
	CPI  R20,0
	BREQ _0x129
	SUBI R20,LOW(1)
_0x129:
_0x128:
_0x127:
_0x11F:
	RCALL SUBOPT_0xD
	CPI  R20,0
	BREQ _0x12A
	SUBI R20,LOW(1)
_0x12A:
_0x124:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x11A
	RJMP _0x119
_0x11A:
_0x117:
	SBRS R17,0
	RJMP _0x12B
_0x12C:
	CPI  R20,0
	BREQ _0x12E
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0xF
	RJMP _0x12C
_0x12E:
_0x12B:
_0x12F:
_0xF1:
	LDI  R16,LOW(0)
_0xDC:
	RJMP _0xD7
_0xD9:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	CALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	JMP  _lcd_write_byte

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDS  R26,_faktor
	LDS  R27,_faktor+1
	LDI  R30,LOW(97)
	LDI  R31,HIGH(97)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4:
	LDS  R30,_impuls_S2
	LSL  R30
	LSL  R30
	SWAP R30
	ANDI R30,0xF0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	ST   -Y,R30
	LDS  R30,_impuls_S2
	ST   -Y,R30
	CALL _checkPBit
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R10
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R9
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R8
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R11
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x8:
	CLR  R30
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	ST   -Y,R30
	CLR  R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xB:
	CALL __long_delay_G2
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xC:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xD:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xE:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	CALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_bcd2bin:
	ld   r30,y
	swap r30
	andi r30,0xf
	mov  r26,r30
	lsl  r26
	lsl  r26
	add  r30,r26
	lsl  r30
	ld   r26,y+
	andi r26,0xf
	add  r30,r26
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__LSLB3:
	LSL  R30
	LSL  R30
	LSL  R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

